#include <Servo.h>
#define LED_VERTE 4 
#define LED_JAUNE 3
#define LED_ROUGE 2
Servo moteur;    
int barriere; 
int capteur=7;
int detection;
int barriereposition=0;

void setup(){
  pinMode(capteur,INPUT);
  pinMode(LED_VERTE, OUTPUT);  
  pinMode(LED_JAUNE, OUTPUT);
  pinMode(LED_ROUGE, OUTPUT);
  digitalWrite(LED_ROUGE, HIGH);}

void loop(){
    detection = digitalRead(capteur);
    if (detection == 1){ // rien
      fermer();   
      delay(1000);}
    else { // voiture
      ouvrir();
      delay(1000);}
}
void ouvrir(){
  if (barriereposition == 0){
      digitalWrite(LED_ROUGE, LOW);
      digitalWrite(LED_VERTE, HIGH); 
      delay(500);
      moteur.attach(5);}
  for (barriere = 100; barriere >=10; barriere -=1)
      {moteur.write(barriere); 
      delay(20);}
      barriereposition = 1;
      moteur.detach();  
}
void fermer(){
  if (barriereposition == 1){
      digitalWrite(LED_VERTE, LOW);
      digitalWrite(LED_JAUNE, HIGH);  
      delay(1000);                  
      digitalWrite(LED_JAUNE, LOW);
      digitalWrite(LED_ROUGE, HIGH);
      moteur.attach(5);}
  for (barriere = 10; barriere <=100; barriere +=1) 
      {moteur.write(barriere); 
      delay(20);}  
      barriereposition = 0;
      moteur.detach();    
}
